//LPacker beta

//Copyright 2008 Giannis (John) Chatzikonstantinou
//http://strukturl.blogspot.com
//http://xconst.freeshell.org

// *This file is part of LPacker*
/**
    LPacker is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    LPacker is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with LPacker.  If not, see <http://www.gnu.org/licenses/>.
*/

// Various Bubble Sort Algorithms: By Width, Height, Area, Squareness etc.
void bubblesortw(ArrayList finrectsin) {
  ArrayList finrects=finrectsin;
  lrect lr1;
  lrect lr2;
  lrect lr3;
  boolean sorted=false;
  while (sorted==false) {
    sorted=true;
    for (int i=0, j=finrects.size()-1;i<j;i++) {
      lr1=(lrect)finrects.get(i);
      lr2=(lrect)finrects.get(i+1);
      if (lr2.W>lr1.W) {
        lr3=lr1;
        finrects.set(i, lr2);
        finrects.set(i+1,lr3);
        sorted=false;
      }
    }
  }
}
void bubblesorth(ArrayList finrectsin) {
  ArrayList finrects=finrectsin;
  lrect lr1;
  lrect lr2;
  lrect lr3;
  boolean sorted=false;
  while (sorted==false) {
    sorted=true;
    for (int i=0, j=finrects.size()-1;i<j;i++) {
      lr1=(lrect)finrects.get(i);
      lr2=(lrect)finrects.get(i+1);
      if (lr2.H>lr1.H) {
        lr3=lr1;
        finrects.set(i, lr2);
        finrects.set(i+1,lr3);
        sorted=false;
      }
    }
  }
}
void bubblesorta(ArrayList finrectsin) {
  ArrayList finrects=finrectsin;
  lrect lr1;
  lrect lr2;
  lrect lr3;
  boolean sorted=false;
  while (sorted==false) {
    sorted=true;
    for (int i=0, j=finrects.size()-1;i<j;i++) {
      lr1=(lrect)finrects.get(i);
      lr2=(lrect)finrects.get(i+1);
      if (lr2.A>lr1.A) {
        lr3=lr1;
        finrects.set(i, lr2);
        finrects.set(i+1,lr3);
        sorted=false;
      }
    }
  }
}
void bubblesorts(ArrayList finrectsin) {
  ArrayList finrects=finrectsin;
  lrect lr1;
  lrect lr2;
  lrect lr3;
  boolean sorted=false;
  while (sorted==false) {
    sorted=true;
    for (int i=0, j=finrects.size()-1;i<j;i++) {
      lr1=(lrect)finrects.get(i);
      lr2=(lrect)finrects.get(i+1);
      if (abs(lr2.W-lr2.H)<abs(lr1.W-lr1.H)) {
        lr3=lr1;
        finrects.set(i, lr2);
        finrects.set(i+1,lr3);
        sorted=false;
      }
    }
  }
}
void bubblesortp(ArrayList finrectsin) {
  ArrayList finrects=finrectsin;
  lrect lr1;
  lrect lr2;
  lrect lr3;
  boolean sorted=false;
  while (sorted==false) {
    sorted=true;
    for (int i=0, j=finrects.size()-1;i<j;i++) {
      lr1=(lrect)finrects.get(i);
      lr2=(lrect)finrects.get(i+1);
      if (lr2.W+lr2.H<lr1.W+lr1.H) {
        lr3=lr1;
        finrects.set(i, lr2);
        finrects.set(i+1,lr3);
        sorted=false;
      }
    }
  }
}
